/*:
![Swift Design Patterns](patterns-01.png)

# Creational Design Patterns

Creational design patterns provide various object creation mechanisms, which increase flexibility and reuse of existing code.

## Factory Method ★★★

Provides an interface for creating objects in a superclass, but allows subclasses to alter the type of objects that will be created.

* [Main article →](https://refactoring.guru/design-patterns/factory-method)
* [Conceptual example](Factory%20Method%20Conceptual%20Example)
* [Real-world example](Factory%20Method%20Real%20World%20Example)

## Abstract Factory ★★★

Lets you produce families of related objects without specifying their concrete classes.

* [Main article →](https://refactoring.guru/design-patterns/abstract-factory)
* [Conceptual example](Abstract%20Factory%20Conceptual%20Example)
* [Real-world example](Abstract%20Factory%20Real%20World%20Example)

## Builder ★★★

Lets you construct complex objects step by step. The pattern allows you to produce different types and representations of an object using the same construction code.

* [Main article →](https://refactoring.guru/design-patterns/builder)
* [Conceptual example](Builder%20Conceptual%20Example)
* [Real-world example](Builder%20Real%20World%20Example)

## Prototype ★★☆

Lets you copy existing objects without making your code dependent on their classes.

* [Main article →](https://refactoring.guru/design-patterns/prototype)
* [Conceptual example](Prototype%20Conceptual%20Example)
* [Real-world example](Prototype%20Real%20World%20Example)

## Singleton ★★☆

Lets you ensure that a class has only one instance, while providing a global access point to this instance.

* [Main article →](https://refactoring.guru/design-patterns/singleton)
* [Conceptual example](Singleton%20Conceptual%20Example)
* [Real-world example](Singleton%20Real%20World%20Example)
 */
